Subject: Re: [PATCH] 2.6.18-rt7: PowerPC: fix breakage in threaded fasteoi type IRQ handlers

From: Sergei Shtylyov <[email-masked]>
Date: Sun, 19 Nov 2006 23:31:36 +0300

Hello.

Ingo Molnar wrote:

>>What do you need an ack() for on fasteoi ? On all fasteoi controllers 
>>I have, ack is implicit by obtaining the vector number and all there 
>>is is an eoi...

> it's a compatibility hack only. Threaded handlers are a different type 
> of flow, but often the fasteoi handler is not changed to the threaded 
> handler so i changed it to be a threaded handler too.

   The fasteoi flow seem to only had been used for x86 IOAPIC in the RT patch 
only *before* PPC took to using them in the mainline...

> threaded handlers need a mask() + an ack(), because that's the correct

    Not all of them. This could be customized on type-by-type basis. I.e. we 
could call eoi() instead of ack() for fasteoi chips without having to resort 
to the duplicated ack/eoi handlers.

> model to map them to kernel threads - threaded handlers can be delayed 
> for a long time if something higher-prio is preempting them.
> 
> 	Ingo

WBR, Sergei